//
//	test the DalUtils class
//

#include <cassert>

#include "Dal.h"
#include "../src/OalDalUtils.h"

#define NUM_OF(a)	(sizeof(a)/sizeof(a[0]))

int main()
{
	int8 i8[] = { 0, 126, 127, 128, 129, 130, 255 };
	unsigned i8u[] = { 0, 126, 127, 128, 129, 130, 255 };

	int16 i16[] = { 0, 32766, 32767, -32768, -32767, -1 };
	unsigned i16u[] = { 0, 32766, 32767, 32768, 32769, 65535 };

	int32 i32[] = { 0, 2147483647, -2147483647-1, -1 };
	unsigned i32u[] = { 0, 2147483647, 2147483647U+1, ~0U };

	for (unsigned n=0; n<NUM_OF(i8); ++n)
		assert(OalDalUtils::unsigned32(i8[n]) == i8u[n]);

	for (unsigned n=0; n<NUM_OF(i16); ++n)
		assert(OalDalUtils::unsigned32(i16[n]) == i16u[n]);

	for (unsigned n=0; n<NUM_OF(i32); ++n)
		assert(OalDalUtils::unsigned32(i32[n]) == i32u[n]);

	return 0;
}

