!
!   checkbadpix.f90 --- check OAL_getBadPixelList call
!
!   AUTHOR:
!       UL, Fri Mar 23 14:51:19 MET 2001
!
!   $Header: /home/sasbuild/repositories/sasdev/sas/packages/oal/f90test/checkbadpix.f90,v 1.2 2003/06/16 08:41:35 gvacanti Exp $
!
program checkbadpix

use oal             ! use the ODF Access Layer
use caloaldefs
use errorhandling

    implicit none
    integer(int16), dimension(:), pointer :: &
                                   rawX, rawY, badPixType, yextent
    logical, dimension(:), pointer :: uplinked
    integer :: i, ccd

    call OAL_setState(EMOS1)
    do ccd=EMOS_CCD_FIRST, EMOS_CCD_LAST
        call OAL_setState(ccdNr=ccd)

        if (OAL_getBadPixelList(rawX, rawY, badPixType, yextent, &
                                uplinked)) then
            write(*, *) 'List of hot pixel is'
            write (*, *) 'EMOS1 chip #', ccd, ' has ', &
                         size(rawX), ' bad pixels:'
            write (*, *) '   x    y   defect  y-extent uplinked'
            do i=0, size(rawX)-1
                 write(*, '(I5,I5,I9,I10,5X,L1)') rawX(i), rawY(i), &
                       badPixType(i), yextent(i), uplinked(i)
            enddo
            call OAL_releaseMemory(rawX, rawY)
            call OAL_releaseMemory(badPixType, yextent)
            call OAL_releaseMemory(uplinked)
        else
            write(*, *) 'The ODF contains no bad pixel tables'
        endif
    enddo
end program
