!
!   oaltest.f90 --- f90 program to test the OAL
!
!   DESCRIPTION:
!       This program tests the correctness of OAL by
!       performing a sequence of subroutine calls followed by
!       checks of the output. If any of these checks fails, the
!       program shall exit with a non-zero return value. If all tests
!       succeed 0 will be returned to the calling environment.
!
!   AUTHOR:
!       UL, Wed Dec 17 16:53:31 MET 1997
!
!   $Header: /home/sasbuild/repositories/sasdev/sas/packages/oal/f90test/oaltest2.f90,v 1.7 2003/06/16 08:41:35 gvacanti Exp $
!
program oaltest

use oal             ! use the ODF Access Layer
use caloaldefs
use errorhandling

    implicit none
    integer expNr, ccdNr
    character(len=512) :: f1, f2
    type(SpacecraftAttitudeType) :: att
    real(kind=double), dimension(0:2, 0:2) :: mat
    integer i, j

    !
    !   OAL_toAttitudeMatrix
    !
    att%ra = .5*acos(-1.);    ! PI/2
    att%apos = 0.d0
    att%dec = 0.d0
    call OAL_toAttitudeMatrix(att, mat)
    do i=0, 2
        write(*, '(3(F12.8, 1X))') (mat(i, j), j=0, 2)
    enddo

    !
    !   ----- open the ODF in directory odfDir and obtain infos ----------
    !
    call OAL_openOdf('../odf')
    call OAL_setState('../odf/0010_PPPPPPOOLL_PNS00104IME.FIT')
    call OAL_getState(exposureNr = expNr, ccdNr =ccdNr)
    write(*, *) 'exposure number: ', expNr
    write(*, *) 'ccd number     : ', ccdNr

    call OAL_openOdf('')
    f1 = OAL_expandSetName('odf(epn, timi, 25, 4)')
    write(*, *) f1
    call OAL_setState(f1)

    call OAL_setState(dataMode=AUXILIARY)
    call OAL_selectFile(0, f2)
    write(*, *) f2

end program
