//-----------------------------------------------------------------------------
//
//						XMM Science Analysis System (SAS)
//					   (c) 1997-2010 European Space Agency
//
//-----------------------------------------------------------------------------
//
//	OalDalUtils.h	--- convenience stuff which makes life with the Dal simpler
//
//	CHANGE HISTORY:
//		UL, 1998-08--7: 1.0.0: - first version
//
//	AUTHOR:
//		U. Lammers, Fri Aug  7 12:43:04 MET DST 1998
//
//	REFERENCES:
//		[1]: Software Specification Document for the XMM Science Analysis
//			 Subsystem, M. Dahlem et. al., 
//
//	$Header: /home/sasbuild/repositories/sasdev/sas/packages/oal/src/OalDalUtils.h,v 1.3 2003/06/16 08:41:35 gvacanti Exp $
///

#ifndef OALDALUTILS_H
#define OALDALUTILS_H

#include "Dal.h"

#define EXPAND(type)	\
	(static_cast<unsigned type>(val))
//	(val >= 0 ? val : (static_cast<unsigned type>(~0) >> 1) - val)

class OalDalUtils {
public:
	static unsigned unsigned32(int32 val) { return EXPAND(int); }
	static unsigned unsigned32(int16 val) { return EXPAND(short); }
	static unsigned unsigned32(uint16 val) { return val; }
	static unsigned unsigned32(int8 val) { return EXPAND(char); }
		//
		//	PRUPOSE:
		//		In the absense of unsigned types in the Dal, intepret
		//		a signed value (int8/int16/int32) as unsigned according
		//		to 2-complement rules for signed/unsigned. E.g. for int16
		//
		//			32766 -> 32766
		//			32767 -> 32767
		//		   -32768 -> 32768
		//		   -32767 -> 32769
		//		   -1	  -> 64535
		//
		//	ARGUMENTS:
		//		I: val	: the value to convert
		//
		//	RETURNS:
		//		value corresponding to <val> expressed as unsigned
		//
		
};

#endif

