//-----------------------------------------------------------------------------
//
//						XMM Science Analysis System (SAS)
//					   (c) 1997-2010 European Space Agency
//
//-----------------------------------------------------------------------------
//
//	OalUtils.cc	--- OAL specific utility functions (implementation)
//
//	CHANGE HISTORY:
//		UL, 1998-08-12: 1.0.0: - first version
//		UL, 1999-04-28: 1.1.0: - fatal -> error
//		UL, 1999-12-15: 1.1.1: - closed a minor memory leak
//							   - made input format for Ra/Dec string more
//								 flexible
//		UL, 2000-10-19: 1.2.0: - fixed bug in ra/DecToRadians() which caused
//								 small negative arguments to be considered
//								 with wrong sign (this closes SSC-SPR-1989)
//
//	AUTHOR:
//		U. Lammers, Wed Aug 12 18:01:41 MET DST 1998
//
//	REFERENCES:
//		[1]: Software Specification Document for the XMM Science Analysis
//			 Subsystem, M. Dahlem et. al., 
//
//	$Header: /home/sasbuild/repositories/sasdev/sas/packages/oal/src/OalUtils.cc,v 1.11 2003/06/16 08:41:35 gvacanti Exp $
//

#include "OalUtils.h"
#include "stringutil.h"
#include "Tracer.h"
#include "errstr.h"

string OalUtils::uncomment(const string &s)
{
	string scop(s);

	string::size_type pos;
	if ((pos = scop.rfind("/ ")) != string::npos)
		scop = scop.substr(0, pos-2);

	return trim(scop, true);
} // OalUtils::uncomment()
